/**
 * @file
 * Initializes Affirm API for monthly payment promotion.
 */

(function ($) {
  Drupal.behaviors.custom_uc_affirm_mpp = {
    attach: function (context, settings) {
      var public_key = Drupal.settings.uc_affirm.public_api_key;
      var listprice = '';
      var month = Drupal.settings.uc_affirm.months;
      var arp = Drupal.settings.uc_affirm.arp;
      var _affirm_config = {
        // Use the PUBLIC API KEY Affirm sent you.
        public_api_key: public_key,
        script: "https://cdn1-sandbox.affirm.com/js/v2/affirm.js"
      };
      (function (l, g, m, e, a, f, b) {
        var d, c = l[m] || {}, h = document.createElement(f), n = document.getElementsByTagName(f)[0], k = function (a, b, c) {
          return function () {
            a[b]._.push([c, arguments])
          };
        };
        c[e] = k(c, e, "set");
        d = c[e];
        c[a] = {};
        c[a]._ = [];
        d._ = [];
        c[a][b] = k(c, a, b);
        a = 0;
        for (b = "set add save post open empty reset on off trigger ready setProduct".split(" "); a < b.length; a++)
          d[b[a]] = k(c, e, b[a]);
        a = 0;
        for (b = ["get", "token", "url", "items"]; a < b.length; a++)
          d[b[a]] = function () {
          };
        h.async = !0;
        h.src = g[f];
        n.parentNode.insertBefore(h, n);
        delete g[f];
        d(g);
        l[m] = c
      })(window, _affirm_config, "affirm", "checkout", "ui", "script", "ready");
      // Change to your template value for product or cart price.
      if ($('#affirmmpp').length) {
        listprice = $('#affirmmpp').attr('data-value');
        listprice = listprice * 100;
        affirm.ui.ready(function () {
          updateAffirmAsLowAs(listprice)
        });
      }
      if ($(document.getElementsByClassName("cls-affirmmpp").length)) {
        $('a[class="cls-affirmmpp"]').each(function (index, item) {
          $(item).attr('id', 'affirm_mpp_' + index);
          affirm.ui.ready(function () {
            // Payment estimate options.
            var options = {
              apr: arp, /* Percentage assumed APR for loan. */
              months: month, /* Can be 3, 6, or 12. */
              amount: $(item).attr('data-value') * 100, /* USD cents. */
            };
            try {
              // Try and access the function.
              typeof affirm.ui.payments.get_estimate;
            }
            catch (e) {
              /* Stops this function from going any further.
               * Affirm functions are not loaded and will throw an error. */
              return;
            }
            // Use the payment estimate response.
            function handleEstimateResponseCSS(payment_estimate) {
              // The payment comes back in USD cents.
              // Get dollars, round up, and convert to int.
              var dollars = ((payment_estimate.payment + 99) / 100) | 0;
              // Set affirm payment text for large.
              $(item).html("Starting at $" + dollars + " a month. Learn More");
              // Open the customized Affirm learn more modal.
              var a = document.getElementById('affirm_mpp_' + index);
              var iText = ('innerText' in a) ? 'innerText' : 'textContent';
              a[iText] = "Starting at $" + dollars + " a month. Learn More";
              // Open the customized Affirm learn more modal.
              a.onclick = payment_estimate.open_modal;
              a.style.visibility = "visible";
            }
            // Request a payment estimate.
            affirm.ui.payments.get_estimate(options, handleEstimateResponseCSS);
          });
        });
      }
      function updateAffirmAsLowAs(amount) {
        // Only display as low as for items over $10.
        // Change for a different limit.
        if ((amount == null) || (amount < 1000)) {
          return;
        }
        // Payment estimate options.
        var options = {
          apr: arp, /* Percentage assumed APR for loan. */
          months: month, /* Can be 3, 6, or 12. */
          amount: amount /* USD cents. */
        };
        try {
          // Try and access the function.
          typeof affirm.ui.payments.get_estimate;
        }
        catch (e) {
          /* Stops this function from going any further.
           * Affirm functions are not loaded and will throw an error. */
          return;
        }
        // Use the payment estimate response.
        function handleEstimateResponse(payment_estimate) {
          // The payment comes back in USD cents.
          // Get dollars, round up, and convert to int.
          var dollars = ((payment_estimate.payment + 99) / 100) | 0;
          // Set affirm payment text for large.
          var a = document.getElementById('affirmmpp');
          var iText = ('innerText' in a) ? 'innerText' : 'textContent';
          a[iText] = "Starting at $" + dollars + " a month. Learn More";
          // Open the customized Affirm learn more modal.
          a.onclick = payment_estimate.open_modal;
          a.style.visibility = "visible";
        }
        // Request a payment estimate.
        affirm.ui.payments.get_estimate(options, handleEstimateResponse);
      }
      // For handling dynamic variant product price.
      $('#dynamic-affirmmpp').bind('DOMNodeInserted', function (event) {
        if (event.type == 'DOMNodeInserted') {
          var x = this.innerHTML;
          x = parseInt(x);
          x = x * 100;
          updateAffirmAsLowAs(x);
        }
      });
    }
  }
})(jQuery);
